Bug 1016863 - Review Request: rubygem-parallel - Run any kind of code in parallel processes
Review Request: rubygem-parallel - Run any kind of code in parallel processes
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ken Dreyer
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-08 16:18 EDT by Troy Dawson
Modified: 2014-03-07 01:33 EST (History)
4 users (show)

See Also:
Fixed In Version: rubygem-parallel-0.9.2-3.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-03-07 01:33:33 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
ktdreyer: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Troy Dawson 2013-10-08 16:18:28 EDT
Spec URL: http://tdawson.fedorapeople.org/rubygems/rubygem-parallel.spec
SRPM URL: http://tdawson.fedorapeople.org/rubygems/rubygem-parallel-0.8.4-1.fc20.src.rpm
Description: 
Run any code in parallel Processes(use all CPUs) 
or Threads(speedup blocking operations).
Best suited for map-reduce or e.g. parallel downloads/uploads.

Fedora Account System Username: tdawson
Comment 1 Ken Dreyer 2013-10-16 23:38:39 EDT
I can take this review.

Since upstream is shipping a really minimal gem, the rspec tests aren't available in the gem itself. Would you mind including them in the package, and running them in %check?

I think a valid case could be made to petition upstream to ship these in the gem, but let's see what they say about https://github.com/grosser/parallel/issues/81 first :)
Comment 2 Troy Dawson 2014-01-13 15:55:47 EST
Spec URL: http://tdawson.fedorapeople.org/rubygems/rubygem-parallel.spec
SRPM URL: http://tdawson.fedorapeople.org/rubygems/rubygem-parallel-0.9.1-1.fc20.src.rpm

I am so sorry for the delay.  I've been having a terrible time with the tests and then I became very busy.

- Updated to 0.9.1
-- 0.9.1 has the License file, so I was able to take that out of the spec file.
- Added spec and Rakefile as Source1
-- Put comments saying how to create the Source1 tarball
-- Put test in following Fedora packaging guidelines.

I could not get the tests to pass without multiple failures, even in a normal environment.
I have left the test in the spec file, but set with_tests to 0, so that it will build.
If that is adequate for you, that is great.  If you have any hints on getting the tests to not fail, that would be great as well.
Comment 3 Troy Dawson 2014-02-12 14:52:14 EST
Spec URL: http://tdawson.fedorapeople.org/rubygems/rubygem-parallel.spec
SRPM URL: http://tdawson.fedorapeople.org/rubygems/rubygem-parallel-0.9.2-1.fc20.src.rpm

- Updated to latest version
-- Latest version also had a fix to get the tests to run.
-- I had to add one more patch to get the tests to run in an rpm enviroment.

I believe this now fits all requirements.  I would love to get this review finished.
Comment 4 Ken Dreyer 2014-02-12 15:01:43 EST
Perfect. I got lost diving into the test suite failures too. I'll review by the end of this week.
Comment 5 Ken Dreyer 2014-02-12 18:53:32 EST
Hi Troy, the test suite is still failing for me. Here's a scratch build of your SRPM: http://koji.fedoraproject.org/koji/taskinfo?taskID=6523387

"sh: ps: command not found" means we're missing BuildRequire: procps-ng.
Comment 6 Troy Dawson 2014-02-17 17:21:58 EST
Spec URL: http://tdawson.fedorapeople.org/rubygems/rubygem-parallel.spec
SRPM URL: http://tdawson.fedorapeople.org/rubygems/rubygem-parallel-0.9.2-3.fc20.src.rpm

Hi Ken,
Sorry about that.  You are correct in that I didn't try building the new version on koji, nor on a clean mock build

- Added needed dependencies
-- procps-ng, lsof
- Final tweeks of test suite.
Comment 7 Ken Dreyer 2014-02-24 13:00:52 EST
Thanks for pinging me on this. Package approved with no blocking issues.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

Issues:
=======
- Unfortunately the test suite has to be heavily patched, and I don't see any
  links to discussions upstream about the problems there. One of the "SHOULD"
  issues is "patches link to upstream bugs/comments/lists or are otherwise
  justified." so it would be nice to see a link to the bugs. This doesn't block
  approval.

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[-]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Ruby:
[x]: Platform dependent files must all go under %{gem_extdir_mri}, platform
     independent under %{gem_dir}.
[x]: Gem package must not define a non-gem subpackage
[x]: Macro %{gem_extdir} is deprecated.
[x]: Gem package is named rubygem-%{gem_name}
[x]: Package contains BuildRequires: rubygems-devel.
[x]: Gem package must define %{gem_name} macro.
[x]: Pure Ruby package must be built as noarch
[x]: Package does not contain Requires: ruby(abi).
[x]: Package contains Requires: ruby(release).

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Ruby:
[x]: Specfile should use macros from rubygem-devel package.
[x]: Gem package should exclude cached Gem.
[x]: Gem should use %gem_install macro.
[x]: Test suite of the library should be run.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rubygem-parallel-0.9.2-3.fc21.noarch.rpm
          rubygem-parallel-doc-0.9.2-3.fc21.noarch.rpm
          rubygem-parallel-0.9.2-3.fc21.src.rpm
rubygem-parallel.src: W: invalid-url Source1: parallel-0.9.2-spec.tgz
3 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint rubygem-parallel-doc rubygem-parallel
2 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
rubygem-parallel-doc (rpmlib, GLIBC filtered):
    rubygem-parallel

rubygem-parallel (rpmlib, GLIBC filtered):
    ruby(release)
    ruby(rubygems)



Provides
--------
rubygem-parallel-doc:
    rubygem-parallel-doc

rubygem-parallel:
    rubygem(parallel)
    rubygem-parallel



Source checksums
----------------
https://rubygems.org/gems/parallel-0.9.2.gem :
  CHECKSUM(SHA256) this package     : 5aaed25e508ab9eaf45a16f58a38c52ceb16c5544bacad5c12bbe429a20e21e9
  CHECKSUM(SHA256) upstream package : 5aaed25e508ab9eaf45a16f58a38c52ceb16c5544bacad5c12bbe429a20e21e9


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1016863 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Ruby, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 8 Troy Dawson 2014-02-24 15:23:10 EST
New Package SCM Request
=======================
Package Name: rubygem-parallel
Short Description: Run any kind of code in parallel processes
Owners: tdawson
Branches: f19 f20 el6 epel7
InitialCC:
Comment 9 Jon Ciesla 2014-02-24 16:08:13 EST
Git done (by process-git-requests).
Comment 10 Fedora Update System 2014-02-24 16:58:57 EST
rubygem-parallel-0.9.2-3.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/rubygem-parallel-0.9.2-3.fc20
Comment 11 Fedora Update System 2014-02-26 09:07:35 EST
rubygem-parallel-0.9.2-3.fc20 has been pushed to the Fedora 20 testing repository.
Comment 12 Fedora Update System 2014-03-07 01:33:33 EST
rubygem-parallel-0.9.2-3.fc20 has been pushed to the Fedora 20 stable repository.

Note You need to log in before you can comment on or make changes to this bug.